﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;

namespace QPR.QPRSuite.NCalc {
    public class arraytodataset : CustomFunctionBase {

        public arraytodataset(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "Object[]", "String" }) {
        }

        public override object evaluate() {
            Object[] array = (Object[])this.parameters[0];
            if (array == null) return null;
            string columnName = (string)this.parameters[1];
            if (string.IsNullOrEmpty(columnName)) throw new Exception("Column name is not allowed to be empty in ArrayToDataset");
            string[] columns = new string[1];
            columns[0] = columnName;
            DataSet dataset = new DataSet(columns);
            for (int i = 0; i < array.Length; i++) {
                object[] rowData = new object[1];
                rowData[0] = array[i];
                dataset.addRow(rowData);
            }
            return dataset;
        }

    }
}