﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System.Collections.Generic;
using System.Linq;

namespace QPR.QPRSuite.NCalc {

    public class arrayunion : CustomFunctionBase {

        public arrayunion(FunctionArgs args, IContextManager context)
            : base(args, context, 1, new string[] { "object[]", "object[]" }) {
        }

        public override object evaluate() {
            if (this.parameters.Length == 2 && this.parameters[1] != null) {
                object[] inputArray1 = (object[])this.parameters[0];
                object[] inputArray2 = (object[])this.parameters[1];
                if (inputArray1 == null) return inputArray2;
                if (inputArray2 == null) return inputArray1;
                List<object> outputList = inputArray1.ToList();
                foreach (object item in inputArray2.ToList()) {
                    outputList.Add(item);
                }
                return outputList.ToArray();
            } else {
                object[] arrays = (object[])this.parameters[0];
                if (arrays == null || arrays.Count() == 0) return (new List<object>()).ToArray();
                List<object> outputList = new List<object>();
                foreach (object[] itemArray in arrays) {
                    if (itemArray == null || itemArray.Count() == 0) continue;
                    foreach (object item in itemArray) {
                        outputList.Add(item);
                    }
                }
                return outputList.ToArray();
            }
        }

    }
}