﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {

    public class arraywhere : CustomFunctionBase {

        private object[] inputArray;
        private string formula;

        public arraywhere(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "object[]", "string" }) {
            this.inputArray = (object[])this.parameters[0];
            this.formula = (string)this.parameters[1];
        }

        public override object evaluate() {
            if (this.inputArray == null) return null;
            List<object> outputData = new List<object>();
            for (int i = 0; i < inputArray.Length; i++) {
                Dictionary<string, object> parameters = new Dictionary<string, object>();
                parameters.Add("item", inputArray[i]);
                parameters.Add("index", i);
                for (int j = 2; j < this.parameters.Length; j++) {
                    parameters.Add("argument" + (j - 1), this.parameters[j]);
                }
                if (context.getExpressionEngine().evaluateExpressionAsBoolean(formula, parameters)) {
                    outputData.Add(inputArray[i]);
                }
            }
            return outputData.ToArray();
        }

    }
}