﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using QPR.QPRSuite.AcceleratorTools.QPRWebService;
using System;
using System.Collections.Generic;
using System.Linq;

namespace QPR.QPRSuite.NCalc {

    public class getattributes : CustomFunctionBase {

        public getattributes(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "string", "string", "string" }) {
        }

        public override object evaluate() {
            string options = "";
            if (this.parameters.Length > 2) options = (string)this.parameters[2];
            ResultSet results = this.context.getWebServiceClient().queryObjects("[" + (string)this.parameters[0] + "]", "", "", (string)this.parameters[1], options);
            List<string> attributeResults = new List<string>();
            if (results != null && results.ChildElements != null && results.ChildElements.Length > 0) {
                if (results.ChildElements.Length > 1) throw new Exception("Multiple objects were returned in \"getattributes\"");
                for (int i = 0; i < results.ChildElements[0].ChildElements.Length; i++) {
                    attributeResults.Add(((ValueElement)((ResultObject)results.ChildElements[0]).ChildElements[i]).Value);
                }
            }
            return attributeResults.ToArray<string>();
        }

    }
}