﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {

    public class leftjoin : CustomFunctionBase {

        public leftjoin(FunctionArgs args, IContextManager context)
            : base(args, context, 3, new string[] { "DataSet", "DataSet", "string" }) {
        }

        public override object evaluate() {
            DataSet leftDataSet = (DataSet)this.parameters[0];
            DataSet rightDataSet = (DataSet)this.parameters[1];
            string expression = (string)this.parameters[2];
            Dictionary<string, object> arguments = new Dictionary<string, object>();
            arguments.Add("leftDataSet", rightDataSet);
            arguments.Add("rightDataSet", leftDataSet);
            arguments.Add("expression", expression);
            object result = null;
            try {
                result = this.context.getExpressionEngine().evaluateExpressionAsObject("rightjoin([leftDataSet], [rightDataSet], [expression])", arguments);
            } catch (Exception e) {
                throw new Exception("Error in function LeftJoin when evaluating expression: rightjoin([leftDataSet], [rightDataSet], [expression])", e);
            }
            return result;
        }

    }
}