﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using QPR.QPRSuite.AcceleratorTools.QPRWebService;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Web;

namespace QPR.QPRSuite.NCalc {

    public class queryobjects : CustomFunctionBase {

        public queryobjects(FunctionArgs args, IContextManager context)
            : base(args, context, 4, new string[] { "string", "string", "string", "string", "string" }) {
        }

        public override object evaluate() {
            string options = "";
            if (this.parameters.Length >= 5) options = (string)this.parameters[4];
            ResultSet results = this.context.getWebServiceClient().queryObjects((string)this.parameters[0], (string)this.parameters[1], (string)this.parameters[2], (string)this.parameters[3], options);
            List<string> queryResults = new List<string>();
            for (int i = 0; results != null && results.ChildElements != null && i < results.ChildElements.Length; i++) {
                if (((string)this.parameters[3]).ToLower() == "id") {
                    queryResults.Add(((ResultObject)results.ChildElements[i]).Id);
                } else if (results.ChildElements[i].ChildElements != null && results.ChildElements[i].ChildElements.Length > 0) {
                    queryResults.Add(((ValueElement)((ResultObject)results.ChildElements[i]).ChildElements[0]).Value);
                }
            }
            return queryResults.ToArray<string>();
        }

    }
}