﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Collections.Generic;
using System.Globalization;
using QPR.QPRSuite.AcceleratorTools.QPRWebService;

namespace QPR.QPRSuite.NCalc {
    public class queryobjectsfirstattribute : CustomFunctionBase {

        public queryobjectsfirstattribute(FunctionArgs args, IContextManager context)
            : base(args, context, 4, new string[] { "String", "String", "String", "String", "String" }) {
        }

        public override object evaluate() {
            string query = (string)this.parameters[0];
            string filter = (string)this.parameters[1];
            string sortBy = (string)this.parameters[2];
            string attributes = (string)this.parameters[3];
            string options = (this.parameters.Length > 4 && this.parameters[4] != null ? (string)this.parameters[4] : "");
            ResultSet results = this.context.getWebServiceClient().queryObjects(query, filter, sortBy, attributes, options);
            if (results != null && results.ChildElements != null && results.ChildElements.Length > 0 && attributes.ToLower() == "id") {
                return ((ResultObject)results.ChildElements[0]).Id;
            } else if (results != null && results.ChildElements != null && results.ChildElements.Length > 0 && results.ChildElements[0].ChildElements != null && results.ChildElements[0].ChildElements.Length > 0 && ((ValueElement)results.ChildElements[0].ChildElements[0]).Value != null) {
                return ((ValueElement)results.ChildElements[0].ChildElements[0]).Value;
            } else {
                return "";
            }
        }

    }
}