﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using QPR.QPRSuite.AcceleratorTools.QPRWebService;
using System;
using System.Collections.Generic;
using System.Linq;

namespace QPR.QPRSuite.NCalc {
    public class queryobjectsunique : CustomFunctionBase {

        public queryobjectsunique(FunctionArgs args, IContextManager context)
            : base(args, context, 6, new string[] { "String", "String", "String", "String", "String", "String" }) {
        }

        public override object evaluate() {
            string query = (string)this.parameters[0];
            string filter = (string)this.parameters[1];
            string sortBy = (string)this.parameters[2];
            string attributes = (string)this.parameters[3];
            string options = (this.parameters.Length > 4 && this.parameters[4] != null ? (string)this.parameters[4] : "");
            string separator = (string)this.parameters[5];

            ResultSet results = this.context.getWebServiceClient().queryObjects(query, filter, sortBy, attributes, options);
            List<string> data = new List<string>();
            for (int i = 0; results != null && results.ChildElements != null && i < results.ChildElements.Length; i++) {
                if (attributes.ToLower() == "id") {
                    data.Add(((ResultObject)results.ChildElements[i]).Id);
                } else if (results.ChildElements[i].ChildElements != null && results.ChildElements[i].ChildElements.Length > 0) {
                    data.Add(((ValueElement)((ResultObject)results.ChildElements[i]).ChildElements[0]).Value);
                }
            }
            List<string> uniqueData = new List<string>();
            foreach (string item in data.Distinct()) {
                uniqueData.Add(item);
            }

            return String.Join(separator, uniqueData.ToArray());
        }

    }
}