﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Xml.Linq;
using System.Xml;
using System.Xml.XPath;
using System.Linq;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {
    public class selectxmlattribute : CustomFunctionBase {

        public selectxmlattribute(FunctionArgs args, IContextManager context)
            : base(args, context, 5, new string[] { "object", "string", "string", "string", "string" }) {
        }

        public override object evaluate() {
            XElement element = null;
            if (this.parameters[0] == null) {
                return null;
            } else if (this.parameters[0].GetType().Name.ToLower() == "xdocument") {
                element = ((XDocument)this.parameters[0]).Root;
            } else if (this.parameters[0].GetType().Name.ToLower() == "xelement") {
                element = (XElement)this.parameters[0];
            } else {
                throw new Exception("Type of first parameter is wrong in \"SelectXmlAttribute\" function");
            }
            if (element == null) throw new Exception("XML document or element was empty in \"SelectXmlAttribute\" function");
            string xPathQuery = (string)this.parameters[1];
            if (string.IsNullOrEmpty(xPathQuery)) throw new Exception("XPath query was empty in \"SelectXmlAttribute\" function");
            string namespacePrefix = (string)this.parameters[2];
            if (string.IsNullOrEmpty(namespacePrefix)) throw new Exception("Namespace prefix query was empty in \"SelectXmlAttribute\" function");
            string namespaceUri = (string)this.parameters[3];
            if (string.IsNullOrEmpty(namespaceUri)) throw new Exception("Namespace URI query was empty in \"SelectXmlAttribute\" function");
            string attributeName = (string)this.parameters[4];
            if (string.IsNullOrEmpty(attributeName)) throw new Exception("Attribute name was empty in \"SelectXmlAttribute\" function");
            XmlNamespaceManager namespaceManager = new XmlNamespaceManager(new NameTable());
            namespaceManager.AddNamespace(namespacePrefix, namespaceUri);
            XElement xElement = element.XPathSelectElement(xPathQuery, namespaceManager);
            if (xElement == null) return "";
            XAttribute attribute = xElement.Attribute(attributeName);
            if (attribute == null) return "";
            return attribute.Value;
        }

    }
}