﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using QPR.QPRSuite.AcceleratorTools.QPRWebService;
using System;
using System.Collections.Generic;
using System.Globalization;

namespace QPR.QPRSuite.NCalc {

    public class subattributesasarray : CustomFunctionBase {

        private string objectId;
        private string attribute;
        private string subAttribute;
        private string filter;

        public subattributesasarray(FunctionArgs args, IContextManager context)
            : base(args, context, 4, new string[] { "string", "string", "string", "string" }) {
            objectId = Convert.ToString(args.Parameters[0].Evaluate(), CultureInfo.InvariantCulture);
            attribute = Convert.ToString(args.Parameters[1].Evaluate(), CultureInfo.InvariantCulture);
            subAttribute = Convert.ToString(args.Parameters[2].Evaluate(), CultureInfo.InvariantCulture);
            filter = Convert.ToString(args.Parameters[3].Evaluate(), CultureInfo.InvariantCulture);
        }

        public override object evaluate() {
            ResultSet results = this.context.getWebServiceClient().queryObjects("[" + objectId + "]", "", "", attribute, "");
            List<string> attributeValues = new List<string>();
            if (results != null && results.ChildElements != null && results.ChildElements.Length > 0 && results.ChildElements[0].ChildElements != null && results.ChildElements[0].ChildElements.Length > 0 && results.ChildElements[0].ChildElements[0].ChildElements != null) {
                if (String.IsNullOrEmpty(filter)) filter = "true";
                for (int i = 0; i < results.ChildElements[0].ChildElements[0].ChildElements.Length; i++) {
                    Dictionary<string, object> arguments = new Dictionary<string, object>();
                    string queriedAttributeValue = null;
                    for (int j = 0; ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i]).Attributes != null && j < ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i]).Attributes.Length; j++) {
                        string attributeName = ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i]).Attributes[j].Name.ToLower();
                        string attributeValue = ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i]).Attributes[j].Value.ToLower();
                        if (attributeName == subAttribute) {
                            queriedAttributeValue = attributeValue;
                        }
                        arguments[attributeName] = attributeValue;
                    }

                    if (results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements != null) {
                        for (int j = 0; j < results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements.Length; j++) {
                            for (int k = 0; ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements[j]).Attributes != null && k < ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements[j]).Attributes.Length; k++) {
                                string attributeName = ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements[j]).Name.ToLower() + "_" + ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements[j]).Attributes[k].Name.ToLower();
                                string attributeValue = ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements[j]).Attributes[k].Value.ToLower();
                                if (attributeName == subAttribute) {
                                    queriedAttributeValue = attributeValue;
                                }
                                arguments[attributeName] = attributeValue;
                            }
                        }
                    }
                    arguments["ordernumber"] = i;
                    for (int k = 4; k < this.parameters.Length; k++) {
                        arguments["argument" + (k - 3)] = this.parameters[k];
                    }
                    if (Convert.ToBoolean(context.getExpressionEngine().evaluateExpressionAsObject(filter, arguments), CultureInfo.InvariantCulture) && queriedAttributeValue != null && queriedAttributeValue != "") {
                        attributeValues.Add(queriedAttributeValue);
                    }
                }
            }
            return attributeValues.ToArray();
        }
    }
}

