﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using QPR.QPRSuite.AcceleratorTools.QPRWebService;
using System;
using System.Collections.Generic;
using System.Globalization;

namespace QPR.QPRSuite.NCalc {

    public class subattributesasdataset : CustomFunctionBase {

        private string objectId;
        private string attribute;
        private string[] columns;

        public subattributesasdataset(FunctionArgs args, IContextManager context)
            : base(args, context, 3, new string[] { "string", "string", "string[]" }) {
            objectId = Convert.ToString(args.Parameters[0].Evaluate(), CultureInfo.InvariantCulture);
            attribute = Convert.ToString(args.Parameters[1].Evaluate(), CultureInfo.InvariantCulture);
            columns = (string[])args.Parameters[2].Evaluate();
        }

        public override object evaluate() {
            ResultSet results = this.context.getWebServiceClient().queryObjects("[" + objectId + "]", "", "", attribute, "");
            DataSet dataset = new DataSet(this.columns);
            if (results != null && results.ChildElements != null && results.ChildElements.Length > 0 && results.ChildElements[0].ChildElements != null && results.ChildElements[0].ChildElements.Length > 0 && results.ChildElements[0].ChildElements[0].ChildElements != null) {
                for (int i = 0; i < results.ChildElements[0].ChildElements[0].ChildElements.Length; i++) {
                    Dictionary<string, string> rowDataAsDictionary = new Dictionary<string, string>();
                    for (int j = 0; ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i]).Attributes != null && j < ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i]).Attributes.Length; j++) {
                        string attributeName = ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i]).Attributes[j].Name.ToLower();
                        string attributeValue = ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i]).Attributes[j].Value.ToLower();
                        rowDataAsDictionary.Add(attributeName, attributeValue);
                    }

                    if (results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements != null) {
                        for (int j = 0; j < results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements.Length; j++) {
                            for (int k = 0; ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements[j]).Attributes != null && k < ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements[j]).Attributes.Length; k++) {
                                string attributeName = ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements[j]).Name.ToLower() + "_" + ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements[j]).Attributes[k].Name.ToLower();
                                string attributeValue = ((Element)results.ChildElements[0].ChildElements[0].ChildElements[i].ChildElements[j]).Attributes[k].Value.ToLower();
                                rowDataAsDictionary.Add(attributeName, attributeValue);
                            }
                        }
                    }

                    object[] rowData = new object[columns.Length];
                    for (int j = 0; j < columns.Length; j++) {
                        if (rowDataAsDictionary.ContainsKey(columns[j])) {
                            rowData[j] = rowDataAsDictionary[columns[j]];
                        } else {
                            rowData[j] = null;
                        }
                    }
                    dataset.addRow(rowData);
                }
            }
            return dataset;
        }

    }
}

