﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Globalization;

namespace QPR.QPRSuite.NCalc {
    public class sum : CustomFunctionBase {

        public sum(FunctionArgs args, IContextManager context)
            : base(args, context, 1, new string[] { "object[]" }) {
        }

        public override object evaluate() {
            object[] inputArray = (object[])this.parameters[0];
            if (inputArray == null) return 0.0;
            double sum = 0.0;
            for (int i = 0; i < inputArray.Length; i++) {
                if (inputArray[i] != null) {
                    double parsedValue = 0.0;
                    try {
                        parsedValue = Convert.ToDouble(inputArray[i], CultureInfo.InvariantCulture);
                    } catch (Exception e) {
                        throw new Exception("Value \"" + inputArray[i] + "\" cannot be converted to numeric");
                    }
                    sum += parsedValue;
                }
            }
            return sum;
        }

    }
}