﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {

    public class transform : CustomFunctionBase {

        public transform(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "object[]", "string" }) {
        }

        public override object evaluate() {
            object[] inputArray = (object[])this.parameters[0];
            string formula = (string)this.parameters[1];
            if (inputArray == null) return null;
            if (formula == null) return new object[inputArray.Length];
            List<object> outputData = new List<object>();
            for (int i = 0; i < inputArray.Length; i++) {
                Dictionary<string, object> parameters = new Dictionary<string, object>();
                parameters.Add("value", inputArray[i]);
                for (int j = 2; j < this.parameters.Length; j++) {
                    parameters.Add("argument" + (j - 1), this.parameters[j]);
                }
                parameters.Add("index", i);
                object transformedValue = context.getExpressionEngine().evaluateExpressionAsObject(formula, parameters);
                outputData.Add(transformedValue);
            }
            return outputData.ToArray();
        }

    }
}