﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;

namespace QPR.QPRSuite.NCalc {
    public class transpose : CustomFunctionBase {

        public transpose(FunctionArgs args, IContextManager context)
            : base(args, context, 1, new string[] { "DataSet" }) {
        }

        public override object evaluate() {
            DataSet oldDataSet = (DataSet)this.parameters[0];
            if (oldDataSet == null) return null;
            string[] newColumns = new string[oldDataSet.rowsCount() + 1];
            newColumns[0] = "headers";
            for (int i = 1; i < newColumns.Length; i++) {
                newColumns[i] = "column_" + i;
            }

            DataSet newDataset = new DataSet(newColumns);
            for (int i = 0; i < oldDataSet.columnsCount(); i++) {
                object[] rowData = new object[oldDataSet.rowsCount() + 1];
                rowData[0] = oldDataSet.getColumnName(i);
                for (int j = 0; j < oldDataSet.rowsCount(); j++) {
                    rowData[j + 1] = oldDataSet.getCell(i, j);
                }
                newDataset.addRow(rowData);
            }
            return newDataset;
        }

    }
}