﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;

namespace QPR.QPRSuite.NCalc {

    public class union : CustomFunctionBase {

        public union(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "DataSet", "DataSet" }) {
        }

        public override object evaluate() {
            DataSet oldDataSet1 = (DataSet)this.parameters[0];
            DataSet oldDataSet2 = (DataSet)this.parameters[1];
            if (oldDataSet1 == null) return oldDataSet2;
            if (oldDataSet2 == null) return oldDataSet1;
            if (!oldDataSet1.containsSameColumns(oldDataSet2)) throw new Exception("Datasets don't contain same columns; union is not possible");
            DataSet newDataSet = new DataSet(oldDataSet1.getColumns());
            for (int i = 0; i < oldDataSet1.rowsCount(); i++) {
                oldDataSet1.getRow(i).copyRow(newDataSet);
            }
            for (int i = 0; i < oldDataSet2.rowsCount(); i++) {
                oldDataSet2.getRow(i).copyRow(newDataSet);
            }
            return newDataSet;
        }

    }
}