﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using QPR.QPRSuite.AcceleratorTools.QPRWebService;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {

    public class where : CustomFunctionBase {


        public where(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "dataset", "string" }) {
        }

        public override object evaluate() {
            DataSet oldDataSet = (DataSet)this.parameters[0];
            if (oldDataSet == null) return null;
            string expression = (string)this.parameters[1];
            DataSet newDataSet = new DataSet(oldDataSet.getColumns());
            for (int i = 0; i < oldDataSet.rowsCount(); i++) {
                DataSetRow row = oldDataSet.getRow(i);
                Dictionary<string, object> arguments = new Dictionary<string, object>();
                for (int j = 0; j < oldDataSet.columnsCount(); j++) {
                    arguments.Add(oldDataSet.getColumnName(j), row.getCell(j));
                }
                for (int j = 2; j < this.parameters.Length; j++) {
                    arguments["argument" + (j - 1)] = this.parameters[j];
                }
                if (this.context.getExpressionEngine().evaluateExpressionAsBoolean(expression, arguments)) {
                    oldDataSet.getRow(i).copyRow(newDataSet);
                }
            }
            return newDataSet;
        }

    }
}