﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Xml.Linq;

namespace QPR.QPRSuite.NCalc {
    public class xmlattribute : CustomFunctionBase {

        public xmlattribute(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "xelement", "string", "string" }) {
        }

        public override object evaluate() {
            XElement element = (XElement)this.parameters[0];
            if (element == null) throw new Exception("XML element was empty in \"XMLAttribute\" function");
            string attributeName = (string)this.parameters[1];
            string defaultValue = "";
            if (this.parameters.Length > 2 && this.parameters[2] != null) defaultValue = (string)this.parameters[2];
            XAttribute attribute = element.Attribute(attributeName);
            if (attribute == null) return defaultValue;
            return attribute.Value;
        }

    }
}