﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;

namespace QPR.QPRSuite.NCalc {
    public class xpathencode : CustomFunctionBase {

        public xpathencode(FunctionArgs args, IContextManager context)
            : base(args, context, 1, new string[] { "string" }) {
        }

        public override object evaluate() {
            string searchString = (string)this.parameters[0];
            if (string.IsNullOrEmpty(searchString)) return searchString;
            string returnString = string.Empty;
            char[] quoteChars = new char[] { '\'', '"' };

            int quotePos = searchString.IndexOfAny(quoteChars);
            if (quotePos == -1) {
                returnString = "'" + searchString + "'";
            } else {
                returnString = "concat(";
                while (quotePos != -1) {
                    string subString = searchString.Substring(0, quotePos);
                    returnString += "'" + subString + "', ";
                    if (searchString.Substring(quotePos, 1) == "'") {
                        returnString += "\"'\", ";
                    } else {
                        //must be a double quote
                        returnString += "'\"', ";
                    }
                    searchString = searchString.Substring(quotePos + 1,
                                     searchString.Length - quotePos - 1);
                    quotePos = searchString.IndexOfAny(quoteChars);
                }
                returnString += "'" + searchString + "')";
            }
            return returnString;
        }

    }
}
