﻿using System;

namespace QPR.QPRSuite.AcceleratorTools {
    //Interface for Metrics Client. Model id is provided for every operation. In QPR API there is only one model opened at a time. If a different model needs to be opened, that is handled automatically.
    public interface IMetricsClient : IDisposable {
        void openModel(int modelId);
        void refreshDrillDown(int modelId, int targetObjectId);
        void applyInheritanceProperties(int modelId, int scorecardId, string applyParameter, int applyWholeChain);
        void recalculate(int modelId, int periodId, object date);
        int getModelIdByName(string modelName);
    }
}
