﻿using System;
using System.Collections.Generic;

namespace QPR.QPRSuite.AcceleratorTools {
    public interface IModellingClient : IDisposable {
        void openModel(int modelId);
        void saveModel();
        void closeModelWithoutSaving();
        int createElement(int modelId, string typename, string elementName, string parameters);
        string createInstance(int modelId, int elementId, string parameters);
        void setProperty(int modelId, int elementId, string propertyName, object value);
        object getProperty(int modelId, int elementId, string propertyName);
        int deleteElement(int modelId, int elementId, string parameters);
        int getModelIdByName(string modelName);
    }
}
