﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace QPR.QPRSuite.AcceleratorTools {

    public abstract class LoggerBase : ILogger {

        private IContextManager context;
        private LogLevel logLevel;

        public LoggerBase(IContextManager context) {
            this.context = context;

            string logLevel = this.context.getOptionalApplicationSetting("loglevel");
            if (string.IsNullOrEmpty(logLevel)) logLevel = "information";

            switch (logLevel.ToLower()) {
                case "verbose":
                    this.logLevel = LogLevel.verbose;
                    break;
                case "information":
                    this.logLevel = LogLevel.information;
                    break;
                case "none":
                    this.logLevel = LogLevel.none;
                    break;
                default:
                    this.logLevel = LogLevel.error;
                    break;
            }
        }

        public bool doWriteLine(LogLevel logLevel) {
            return (this.logLevel == LogLevel.verbose || (this.logLevel == LogLevel.information && logLevel != LogLevel.verbose) || (this.logLevel == LogLevel.error && (logLevel != LogLevel.information && logLevel != LogLevel.verbose)));
        }

        public abstract void writeLog(string logLine, LogLevel loglevel);

        public void Dispose() {
        }

    }
}
